cd;                                 % Working folder, need adjusted by the user

%% Table 11. Two-level CES bootstrapping    
clear all; warning off; 
resultfilename = 'Results.xls';     % Results file
datafile = 'Data_T11_T12.xls';
N_Iter = 1000;                      % Number of iterations of bootstraping
Max_Iter = 10000;                   % Max number of iteration

Two_Level_CES = @(b,x)(b(5)+ (1/b(2))* ...
        (log(b(3) * (b(4)*x(:,2).^b(1) + (1-b(4))*x(:,3).^b(1)).^(b(2)/b(1)) + (1-b(3))*x(:,1).^b(2)) - ...
         log(b(3) * (b(4)*x(:,5).^b(1) + (1-b(4))*x(:,6).^b(1)).^(b(2)/b(1)) + (1-b(3))*x(:,4).^b(2)))) ;     
b2ces  = [0.50, 0.50, 0.50, 0.50, 0.01]; 

Main2CES = NaN(4,N_Iter);
Results_All = [1,1,2,2,3,3,4,4,5,5,6,6,7,8]';
for cg = 0:3
    rand('seed',37595); 
    Coef2CES = NaN(5,N_Iter);        
    
    data = xlsread(datafile, num2str(cg));
    y0 = data(:,1); X0 = data(:,2:7); 
    Est_All = fitnlm(X0,y0,Two_Level_CES,b2ces);
    result_a = table2array(Est_All.Coefficients(:,1)); 
    
    zz=data(:,1:7); W = data(:,8); T = length(data); 
    index = zeros(T,1); data = [data,index];
    y = data(:,1); X = data(:,2:7); 
    bstp_data = data;
    j=1;
    for i = 1:1:Max_Iter
        zz1 = datasample(zz,T,'Replace',true,'Weights',W);
        T = length(zz1);
        index = ones(T,1)*j;
        zz1 = [zz1, W, index];
        bstp_data = [bstp_data;zz1];
        X = zz1(:,2:7);
        y = zz1(:,1);
        
        try                          
            nlls_estimate = fitnlm(X,y,Two_Level_CES,b2ces);
            cc = table2array(nlls_estimate.Coefficients(:,1));    

            if cc(1)<1 && cc(1)>-1
                Coef2CES(:,j)=cc;
                j=j+1;
                if rem(j,100)==0
                    j
                end
            end
        catch                        
        end
        if j > N_Iter
            break
        end
    end   

    sigma2 =  1./(1-Coef2CES(1,:));
    result_b = (1-tcdf(result_a./std(Coef2CES,0,2),T))*2; 
    result_b = (reshape([result_b result_b]',1,10))';
    result_b = [result_b;prctile(sigma2,[16 ,84])'];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    
    result_a = [result_a std(Coef2CES,0,2)];
    result_a = (reshape(result_a',1,10))';
    result_a(9:10,1) = result_a(9:10,1)*100;
    result_a = round(100*result_a)/100;  
    result_a(11,1) = 1/(1-result_a(1,1));result_a(12,1)=result_a(11,1);
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_a = round(100*result_a)/100;
    
    Results_All = [Results_All,result_a,result_b];
    Main2CES(cg+1,:) = sigma2;
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T11",'L3')   
xlswrite(resultfilename,clock,"T11",'A30')

figure(1); 
subplot(2,2,1)
hold on
histogram(Main2CES(1,:),[0:0.1:6]);
title('All' )
subplot(2,2,2)
hold on
histogram(Main2CES(2,:),[0:0.1:6]);
title('Advanced')
subplot(2,2,3)
hold on
histogram(Main2CES(3,:),[0:0.1:6]);
title('Emerging')
subplot(2,2,4)
hold on
histogram(Main2CES(3,:),[0:0.1:6]);
title('LIDCs')


%% Table 12. Two-level CES bootstrapping    
clear all; warning off; 
resultfilename = 'Results.xls';      % Results file
datafile = 'Data_T11_T12.xls';
N_Iter = 1000;                       % Number of iterations of bootstraping
Max_Iter = 10000;                    % Max number of iteration

CES_CD = @(b,x)(b(4)+ ...
        ((1-b(2))*log(x(:,1))+b(2)/b(1)*log(b(3)*x(:,2).^b(1)+(1-b(3))*x(:,3).^b(1))) - ...
        ((1-b(2))*log(x(:,4))+b(2)/b(1)*log(b(3)*x(:,5).^b(1)+(1-b(3))*x(:,6).^b(1))));     
bcescd = [0.50, 0.50, 0.50, 0.01];

MainCESCD = NaN(4,N_Iter);

Results_All = [1,1,2,2,3,3,4,4,5,5,6,7]';
for cg = 0:3
    rand('seed',37595); 
    CoefCESCD = NaN(4,N_Iter);        
    
    data = xlsread(datafile, num2str(cg));
    y0 = data(:,1); X0 = data(:,2:7); 
    Est_All = fitnlm(X0,y0,CES_CD,bcescd);
    result_a = table2array(Est_All.Coefficients(:,1)); 
    
    zz=data(:,1:7); W = data(:,8); T = length(data); 
    index = zeros(T,1); data = [data,index];
    y = data(:,1); X = data(:,2:7); 
    bstp_data = data;
    j=1;
    for i = 1:1:Max_Iter
        zz1 = datasample(zz,T,'Replace',true,'Weights',W);
        T = length(zz1);
        index = ones(T,1)*j;
        zz1 = [zz1, W, index];
        bstp_data = [bstp_data;zz1];
        X = zz1(:,2:7);
        y = zz1(:,1);
        
        try                          
            nlls_estimate = fitnlm(X,y,CES_CD,bcescd);
            cc = table2array(nlls_estimate.Coefficients(:,1));    

            if cc(1)<1 && cc(1)>-1
                CoefCESCD(:,j)=cc;
                j=j+1;
                if rem(j,100)==0
                    j
                end
            end
        catch                        
        end
        if j > N_Iter
            break
        end
    end   

    sigma2 =  1./(1-CoefCESCD(1,:));
    result_b = (1-tcdf(result_a./std(CoefCESCD,0,2),T))*2; 
    result_b = (reshape([result_b result_b]',1,8))';
    result_b = [result_b;prctile(sigma2,[16 ,84])'];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    
    result_a = [result_a std(CoefCESCD,0,2)];
    result_a = (reshape(result_a',1,8))';
    result_a(7:8,1) = result_a(7:8,1)*100;
    result_a = round(100*result_a)/100;  
    result_a(9,1) = 1/(1-result_a(1,1));result_a(10,1)=result_a(9,1);
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_a = round(100*result_a)/100;
    
    Results_All = [Results_All,result_a,result_b];
    MainCESCD(cg+1,:) = sigma2;
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T12",'L3')   
xlswrite(resultfilename,clock,"T12",'A30')

figure(2); 
subplot(2,2,1)
hold on
histogram(MainCESCD(1,:),[0:0.1:6]);
title('All' )
subplot(2,2,2)
hold on
histogram(MainCESCD(2,:),[0:0.1:6]);
title('Advanced')
subplot(2,2,3)
hold on
histogram(MainCESCD(3,:),[0:0.1:6]);
title('Emerging')
subplot(2,2,4)
hold on
histogram(MainCESCD(3,:),[0:0.1:6]);
title('LIDCs')




