clear all;
cd;                                 % Working folder, need adjusted by the user
resultfilename = 'Results.xls';     % Results file

%% Table 5. Two-level CES, Alternative Data Frequencies - 2Y and 5Y
Two_Level_CES = @(b,x)(b(5)+ (1/b(2))* ...
        (log(b(3) * (b(4)*x(:,2).^b(1) + (1-b(4))*x(:,3).^b(1)).^(b(2)/b(1)) + (1-b(3))*x(:,1).^b(2)) - ...
         log(b(3) * (b(4)*x(:,5).^b(1) + (1-b(4))*x(:,6).^b(1)).^(b(2)/b(1)) + (1-b(3))*x(:,4).^b(2)))) ;     
beta0 = [0.50, 0.50, 0.50, 0.50, 0.01];

datafile = 'Data_T5_T6_2Y.xls';
Results_All = [1,1,2,2,3,3,4,4,5,5,6,6,7,8]';
for cg = 0:3
    data = xlsread(datafile, num2str(cg));
    y = data(:,1); X = data(:,2:7); % gr kp kg ll L.kp L.kg, L.ll
    Est_All = fitnlm(X,y,Two_Level_CES,beta0);
    result_a = (reshape((table2array(Est_All.Coefficients(:,1:2)))',1,10))';
    result_a(9:10,1) = result_a(9:10,1)*100;
    result_a = round(100*result_a)/100;
    result_a(11,1) = 1/(1-result_a(1,1));
    result_a(12,1) = (Est_All.CoefficientCovariance(1:1)^0.5)*((1-result_a(1,1))^(-2));
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_b = (reshape([table2array(Est_All.Coefficients(:,4)), table2array(Est_All.Coefficients(:,4))]',1,10))';
    result_b = [result_b;(1-normcdf(abs(result_a(11,1)/result_a(12,1))))*2;(1-normcdf(abs(result_a(11,1)/result_a(12,1))))*2];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    Results_All = [Results_All,result_a,result_b];
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T5",'T3')

datafile = 'Data_T5_T6_5Y.xls';
Results_All = [1,1,2,2,3,3,4,4,5,5,6,6,7,8]';
for cg = 0:3
    data = xlsread(datafile, num2str(cg));
    y = data(:,1); X = data(:,2:7); % gr kp kg ll L.kp L.kg, L.ll
    Est_All = fitnlm(X,y,Two_Level_CES,beta0);
    result_a = (reshape((table2array(Est_All.Coefficients(:,1:2)))',1,10))';
    result_a(9:10,1) = result_a(9:10,1)*100;
    result_a = round(100*result_a)/100; 
    result_a(11,1) = 1/(1-result_a(1,1));
    result_a(12,1) = (Est_All.CoefficientCovariance(1:1)^0.5)*((1-result_a(1,1))^(-2));
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_b = (reshape([table2array(Est_All.Coefficients(:,4)), table2array(Est_All.Coefficients(:,4))]',1,10))';
    result_b = [result_b;(1-normcdf(abs(result_a(11,1)/result_a(12,1))))*2;(1-normcdf(abs(result_a(11,1)/result_a(12,1))))*2];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    Results_All = [Results_All,result_a,result_b];
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T5",'AC3')
xlswrite(resultfilename,clock,"T5",'A30')


%% Table 6. CES-CD, Alternative Data Frequencies - 2Y and 5Y 
CES_CD =  @(b,x)(b(4)+ ...
        ((1-b(2))*log(x(:,1))+b(2)/b(1)*log(b(3)*x(:,2).^b(1)+(1-b(3))*x(:,3).^b(1))) - ...
        ((1-b(2))*log(x(:,4))+b(2)/b(1)*log(b(3)*x(:,5).^b(1)+(1-b(3))*x(:,6).^b(1))));     
beta0 =[0.50, 0.50, 0.50, 0.01];

datafile = 'Data_T5_T6_2Y.xls';
Results_All = [1,1,2,2,3,3,4,4,5,5,6,7]';
for cg = 0:3
    data = xlsread(datafile, num2str(cg));
    y = data(:,1); X = data(:,2:7); % gr kp kg ll L.kp L.kg, L.ll
    Est_All = fitnlm(X,y,CES_CD,beta0);
    result_a = (reshape((table2array(Est_All.Coefficients(:,1:2)))',1,8))';
    result_a(7:8,1) = result_a(7:8,1)*100;
    result_a = round(100*result_a)/100;
    result_a(9,1) = 1/(1-result_a(1,1));
    result_a(10,1) = (Est_All.CoefficientCovariance(1:1)^0.5)*((1-result_a(1,1))^(-2));    
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_b = (reshape([table2array(Est_All.Coefficients(:,4)), table2array(Est_All.Coefficients(:,4))]',1,8))';
    result_b = [result_b;(1-normcdf(abs(result_a(9,1)/result_a(10,1))))*2;(1-normcdf(abs(result_a(9,1)/result_a(10,1))))*2];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    Results_All = [Results_All,result_a,result_b];
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T6",'T3')
 
datafile = 'Data_T5_T6_5Y.xls';
beta0 =[0.50, 0.50, 0.50, 0.01];
Results_All = [1,1,2,2,3,3,4,4,5,5,6,7]';
for cg = 0:3
    data = xlsread(datafile, num2str(cg));
    y = data(:,1); X = data(:,2:7); % % gr kp kg ll L.kp L.kg, L.ll
    Est_All = fitnlm(X,y,CES_CD,beta0);
    result_a = (reshape((table2array(Est_All.Coefficients(:,1:2)))',1,8))';
    result_a(7:8,1) = result_a(7:8,1)*100;
    result_a = round(100*result_a)/100;
    result_a(9,1) = 1/(1-result_a(1,1));
    result_a(10,1) = (Est_All.CoefficientCovariance(1:1)^0.5)*((1-result_a(1,1))^(-2));    
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_b = (reshape([table2array(Est_All.Coefficients(:,4)), table2array(Est_All.Coefficients(:,4))]',1,8))';
    result_b = [result_b;(1-normcdf(abs(result_a(9,1)/result_a(10,1))))*2;(1-normcdf(abs(result_a(9,1)/result_a(10,1))))*2];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    Results_All = [Results_All,result_a,result_b];
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T6",'AC3')
xlswrite(resultfilename,clock,"T6",'A30')
