clear all;
cd;                                 % Working folder, need adjusted by the user
resultfilename = 'Results.xls';     % Results file

%% Table 7. Two-level CES, TFE
Two_Level_CES = @(b,x)(b(5)+ (1/b(2))* ...
    (log(b(3) * (b(4)*x(:,2).^b(1) + (1-b(4))*x(:,3).^b(1)).^(b(2)/b(1)) + (1-b(3))*x(:,1).^b(2)) - ...
     log(b(3) * (b(4)*x(:,5).^b(1) + (1-b(4))*x(:,6).^b(1)).^(b(2)/b(1)) + (1-b(3))*x(:,4).^b(2)))) + ...
     b(6)*x(:,7) ;
beta0 = [0.50, 0.50, 0.50, 0.50, 0.01,0];

filename = 'Data_T7_T8_HalfTFE.xls';
Results_All = [1,1,2,2,3,3,4,4,5,5,6,6,7,8]';
for cg = 0:3
    data = xlsread(filename, num2str(cg));
    y = data(:,1); X = data(:,2:end); % gr kp kg ll L.kp L.kg, L.ll
    Est_All = fitnlm(X,y,Two_Level_CES,beta0);
    result_a = (reshape((table2array(Est_All.Coefficients(1:5,1:2)))',1,10))';
    result_a(9:10,1) = result_a(9:10,1)*100;
    result_a = round(100*result_a)/100;
    result_a(11,1) = 1/(1-result_a(1,1));
    result_a(12,1) = (Est_All.CoefficientCovariance(1:1)^0.5)*((1-result_a(1,1))^(-2));    
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_b = (reshape([table2array(Est_All.Coefficients(1:5,4)), table2array(Est_All.Coefficients(1:5,4))]',1,10))';
    result_b = [result_b;(1-normcdf(abs(result_a(11,1)/result_a(12,1))))*2;(1-normcdf(abs(result_a(11,1)/result_a(12,1))))*2];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    Results_All = [Results_All,result_a,result_b];
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T7",'T3')


Two_Level_CES = @(b,x)(b(5)+ (1/b(2))* ...
    (log(b(3) * (b(4)*x(:,2).^b(1) + (1-b(4))*x(:,3).^b(1)).^(b(2)/b(1)) + (1-b(3))*x(:,1).^b(2)) - ...
     log(b(3) * (b(4)*x(:,5).^b(1) + (1-b(4))*x(:,6).^b(1)).^(b(2)/b(1)) + (1-b(3))*x(:,4).^b(2)))) + ...
     b(6)*x(:,7) + b(7)*x(:,8) + b(8)*x(:,9);
beta0 = [0.50, 0.50, 0.50, 0.50, 0.01,0,0,0];

filename = 'Data_T7_T8_12TFE.xls';    
Results_All = [1,1,2,2,3,3,4,4,5,5,6,6,7,8]';
for cg = 0:3
    data = xlsread(filename, num2str(cg));
    y = data(:,1); X = data(:,2:end); % gr kp kg ll L.kp L.kg, L.ll
    Est_All = fitnlm(X,y,Two_Level_CES,beta0);
    result_a = (reshape((table2array(Est_All.Coefficients(1:5,1:2)))',1,10))';
    result_a(9:10,1) = result_a(9:10,1)*100;
    result_a = round(100*result_a)/100;
    result_a(11,1) = 1/(1-result_a(1,1));
    result_a(12,1) = (Est_All.CoefficientCovariance(1:1)^0.5)*((1-result_a(1,1))^(-2));      
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_b = (reshape([table2array(Est_All.Coefficients(1:5,4)), table2array(Est_All.Coefficients(1:5,4))]',1,10))';
    result_b = [result_b;(1-normcdf(abs(result_a(11,1)/result_a(12,1))))*2;(1-normcdf(abs(result_a(11,1)/result_a(12,1))))*2];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    Results_All = [Results_All,result_a,result_b];
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T7",'AC3')
xlswrite(resultfilename,clock,"T7",'A30')


%% Table 8. CES-CD, TFE
CES_CD =  @(b,x)(b(4)+ ...
    ((1-b(2))*log(x(:,1))+b(2)/b(1)*log(b(3)*x(:,2).^b(1)+(1-b(3))*x(:,3).^b(1))) - ...
    ((1-b(2))*log(x(:,4))+b(2)/b(1)*log(b(3)*x(:,5).^b(1)+(1-b(3))*x(:,6).^b(1))))+ ...
     b(5)*x(:,7) ;  
beta0 =[0.50, 0.50, 0.50, 0.01,0];

filename = 'Data_T7_T8_HalfTFE.xls'; 
Results_All = [1,1,2,2,3,3,4,4,5,5,6,7]';
for cg = 0:3
    data = xlsread(filename, num2str(cg));
    y = data(:,1); X = data(:,2:end); % gr kp kg ll L.kp L.kg, L.ll
    Est_All = fitnlm(X,y,CES_CD,beta0);
    result_a = (reshape((table2array(Est_All.Coefficients(1:4,1:2)))',1,8))';
    result_a(7:8,1) = result_a(7:8,1)*100;
    result_a = round(100*result_a)/100;
    result_a(9,1) = 1/(1-result_a(1,1));
    result_a(10,1) = (Est_All.CoefficientCovariance(1:1)^0.5)*((1-result_a(1,1))^(-2));      
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_b = (reshape([table2array(Est_All.Coefficients(1:4,4)), table2array(Est_All.Coefficients(1:4,4))]',1,8))';
    result_b = [result_b;(1-normcdf(abs(result_a(9,1)/result_a(10,1))))*2;(1-normcdf(abs(result_a(9,1)/result_a(10,1))))*2];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    Results_All = [Results_All,result_a,result_b];
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T8",'T3')


CES_CD =  @(b,x)(b(4)+ ...
    ((1-b(2))*log(x(:,1))+b(2)/b(1)*log(b(3)*x(:,2).^b(1)+(1-b(3))*x(:,3).^b(1))) - ...
    ((1-b(2))*log(x(:,4))+b(2)/b(1)*log(b(3)*x(:,5).^b(1)+(1-b(3))*x(:,6).^b(1))))+ ...
     b(5)*x(:,7) + b(6)*x(:,8) + b(7)*x(:,9) ; 
beta0 =[0.50, 0.50, 0.50, 0.01,0,0,0];

filename = 'Data_T7_T8_12TFE.xls';    
Results_All = [1,1,2,2,3,3,4,4,5,5,6,7]';
for cg = 0:3
    data = xlsread(filename, num2str(cg));
    y = data(:,1); X = data(:,2:end); % gr kp kg ll L.kp L.kg, L.ll
    Est_All = fitnlm(X,y,CES_CD,beta0);
    result_a = (reshape((table2array(Est_All.Coefficients(1:4,1:2)))',1,8))';
    result_a(7:8,1) = result_a(7:8,1)*100;
    result_a = round(100*result_a)/100;
    result_a(9,1) = 1/(1-result_a(1,1));
    result_a(10,1) = (Est_All.CoefficientCovariance(1:1)^0.5)*((1-result_a(1,1))^(-2));    
    result_a = [result_a; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    result_b = (reshape([table2array(Est_All.Coefficients(1:4,4)), table2array(Est_All.Coefficients(1:4,4))]',1,8))';
    result_b = [result_b;(1-normcdf(abs(result_a(9,1)/result_a(10,1))))*2;(1-normcdf(abs(result_a(9,1)/result_a(10,1))))*2];
    result_b = [result_b; length(Est_All.Fitted);Est_All.Rsquared.Ordinary];
    Results_All = [Results_All,result_a,result_b];
end
Results_All = round(100*Results_All)/100;
xlswrite(resultfilename,Results_All,"T8",'AC3')
xlswrite(resultfilename,clock,"T8",'A30')
